load data_angle.mat y P* Y* D* Z* nbvals bvecs bvals F mean* FAD FAP nsamples

prod = 1;
sample_no = 10;

input = struct;
input.nbvals = nbvals;
input.bvecs = bvecs;
input.bvals = bvals;
L = 0;
xmean = 0;
input.L = L;
input.xmean = xmean;

X0 = zeros(14,1);
X0(2) = prod*F;
X0(3:5) = sqrt(prod*meanP*[1;1;1]);
X0(6:8) = [0;0;0];
X0(9:11) = sqrt(prod*meanD*[1;1;1]);
X0(12:14) = [0;0;0];

data = y(sample_no,:)';
X0(1) = mean(y(sample_no,1:12));

niter = 10;
X = zeros(14,niter);
X(:,1) = X0;

for kk = 1:niter
    
    [yy,J] = fn_DTIPTI_V5(X(:,kk),input);
    
    %disp('Computing Gradient and Hessian...')
    hess = J'*J;
    grad = J'*(data-yy);
    %disp('Computing dX..')
    dX = hess\grad;
    
    Norm(kk) = 0.5*norm(data-yy)^2;%sc = 1
    %disp(['Norm: ' num2str(Norm(kk))])
    s = steplen_DTIPSI_V5(dX,Norm(kk),X(:,kk),data,input);
    %disp(['Step length: ' num2str(s)])
    pause(0.01)
    if s<1e-6 || isnan(s)
        X(:,kk+1:end) = [];
        Norm(kk+1:end) = [];
        break
    end
    X(:,kk+1) = X(:,kk) + s*dX;
    
    
    Y0 = X(1,end);f = X(2,end);
    Y1 = X(3,end);Y2 = X(4,end);Y3 = X(5,end);Y4 = X(6,end);Y5 = X(7,end);Y6 = X(8,end);
    Z1 = X(9,end);Z2 = X(10,end);Z3 = X(11,end);Z4 = X(12,end);Z5 = X(13,end);Z6 = X(14,end);
    
    Y0recon = Y0;
    Frecon = f;%1./(1+exp(-f));
    Pxxrecon = Y1^2;
    Pyyrecon = Y2^2+Y4^2;
    Pzzrecon = Y3^2+Y5^2+Y6^2;
    Pxyrecon = Y1*Y4;
    Pyzrecon = Y2*Y5+Y4*Y6;
    Pxzrecon = Y1*Y6;
    Dxxrecon = Z1^2;
    Dyyrecon = Z2^2+Z4^2;
    Dzzrecon = Z3^2+Z5^2+Z6^2;
    Dxyrecon = Z1*Z4;
    Dyzrecon = Z2*Z5+Z4*Z6;
    Dxzrecon = Z1*Z6;
    
    ErrF = 100*(f-F)/F;
    
    Pmat = [Pxxrecon Pxyrecon Pxzrecon;Pxyrecon Pyyrecon Pyzrecon;Pxzrecon Pyzrecon Pzzrecon];
    [evecP,eigP] = eig(Pmat);eigP = diag(eigP);evecsP = evecP(:,end);
    meanp = mean(eigP);
    ErrMDP = 100*((meanp-meanP)/meanP);
    ErrFAP = 100*(sqrt((3*((eigP(1)-meanp)^2+(eigP(2)-meanp)^2+(eigP(3)-meanp)^2))/(2*(eigP(1)^2+eigP(2)^2+eigP(3)^2)))-FAP)/FAP;
    
    Dmat = [Dxxrecon Dxyrecon Dxzrecon;Dxyrecon Dyyrecon Dyzrecon;Dxzrecon Dyzrecon Dzzrecon];
    [evecD,eigD] = eig(Dmat);eigD = diag(eigD);evecsD = evecD(:,end);
    meand = mean(eigD);
    ErrMDD = 100*((meand-meanD)/meanD);
    ErrFAD = 100*(sqrt((3*((eigD(1)-meand)^2+(eigD(2)-meand)^2+(eigD(3)-meand)^2))/(2*(eigD(1)^2+eigD(2)^2+eigD(3)^2)))-FAD)/FAD;
    ErrRE = 0;
    for ll = 1:nbvals
        sumbP = bvals(ll)*bvecs(:,ll)'*Pmat*bvecs(:,ll);
        sumbD = bvals(ll)*bvecs(:,ll)'*Dmat*bvecs(:,ll);
        ErrRE = ErrRE + (1/length(bvals))*(y(sample_no,ll) - Y0recon*(f*exp(-sumbP)+(1-f)*exp(-sumbD)));
    end
end

thetap = acosd(abs([1 0 0]*evecsP));
thetad = acosd(abs([cosd(30) sind(30) 0]*evecsD));

disp('Original tensors')
P_target
D_target
disp('Reconstructed tensors')
Pmat
Dmat

